/**
 * Created by Grigorii Shovkoplias on 23.03.2016.
 */

import java.io.*;
import java.util.*;

public class TestGen {

    private void gen() throws Exception {
        new File("../tests").mkdir();
        new File("../preliminary").mkdir();
        desc = new PrintWriter("../tests.desc");


        done = 0;
        genSamples();

        //-------------------------first group-------------------------------------------------
        subtask = "subtask1";

        genManual();
        genRand(gand(20));
        genRandAH(gand(20));
        genFullAH(gand(20));
        genFullHA(gand(20));
        genFullAHRandInserted(gand(20), gand(6));
        genFullHARandInserted(gand(20), gand(6));
        genFullAHRandInsertedAH(gand(20), gand(6));
        genFullHARandInsertedAH(gand(20), gand(6));

        genRand(gand(MAXN1));
        genRandAH(gand(MAXN1));
        genFullAH(gand(MAXN1));
        genFullHA(gand(MAXN1));
        genFullAHRandInserted(gand(MAXN1), rand(MAXN1));
        genFullHARandInserted(gand(MAXN1), rand(MAXN1));
        genFullAHRandInsertedAH(gand(MAXN1), rand(MAXN1));
        genFullHARandInsertedAH(gand(MAXN1), rand(MAXN1));

        genRand(MAXN1);
        genRandAH(MAXN1);
        genFullAH(MAXN1);
        genFullHA(MAXN1);
        genFullAHRandInserted(MAXN1, rand(MAXN1));
        genFullHARandInserted(MAXN1, rand(MAXN1));
        genFullAHRandInsertedAH(MAXN1, rand(MAXN1));
        genFullHARandInsertedAH(MAXN1, MAXN2);

        desc.println(String.format("comment_subtask%d=\"n &lt;= %d\"", 1, MAXN1));
        desc.println(String.format("bonus_subtask%d=%d", 1, 47));

        //-------------------------second group-------------------------------------------------

        subtask = "subtask2";

        genRand(gand(MAXN2));
        genRandAH(gand(MAXN2));
        genFullAH(gand(MAXN2));
        genFullHA(gand(MAXN2));
        genFullAHRandInserted(gand(MAXN2), rand(MAXN2));
        genFullHARandInserted(gand(MAXN2), rand(MAXN2));
        genFullAHRandInsertedAH(gand(MAXN2), rand(MAXN2));
        genFullHARandInsertedAH(gand(MAXN2), rand(MAXN2));

        genRand(MAXN2);
        genRandAH(MAXN2);
        genFullAH(MAXN2);
        genFullHA(MAXN2);
        genFullAHRandInserted(MAXN2, rand(MAXN2));
        genFullHARandInserted(MAXN2, rand(MAXN2));
        genFullAHRandInsertedAH(MAXN2, rand(MAXN2));
        genFullHARandInsertedAH(MAXN2, rand(MAXN2));


        desc.println(String.format("comment_subtask%d=\"n &lt;= %d\"", 2, MAXN2));
        desc.println(String.format("bonus_subtask%d=%d", 2, 53));


        desc.close();

    }

    public static void main(String[] args) throws Exception {
        new TestGen().gen();
    }

    private int done = 0;
    private PrintWriter desc;
    private final Random rnd = new Random(3289214075201L);
    private final int MAXN1 = 5000;
    private final int MAXN2 = 100_000;

    private int rand(int n) {
        if (n < 1)
            return 0;
        return rnd.nextInt(n);
    }

    private char randChar() {
        return (char) (rand(26) + 'a');
    }

    private int gand(int n) {
        return rand(n / 2) + n / 2 + 1;
    }

    private boolean coin() {
        return rnd.nextBoolean();
    }

    private long rand(long n) {
        if (n < 1)
            return 0;
        long res = rand(Integer.MAX_VALUE);
        res <<= 32;
        res += rand(Integer.MAX_VALUE);
        res %= n;
        return res;
    }


    private void print(String test) throws IOException {
        done++;
        System.err.println("Generation test #" + done);
        PrintWriter out = new PrintWriter(String.format("../tests/%02d", done));
        out.println(test.length());
        out.println(test);
        out.close();
    }


    private String getPath() {
        return String.format("../tests/%02d", done);
    }

    private void printDesc(String path, String folder, String subtask, int points, String comment) throws IOException {
        desc.println(String.format("%s, folder=%s, subtask=%s, points=%d, comment=\"%s\"", path, folder, subtask, points, comment));
    }

    private String subtask;

    private void printDescT(String comment) throws IOException {
        printDesc(getPath(), "tests", subtask, 0, comment);
    }

    //begin generators

    private void genSamples() throws IOException {
        PrintWriter out;
        String path;
        path = "../preliminary/01";
        out = new PrintWriter(path);
        out.println("5");
        out.println("ahaha");
        out.close();
        printDesc(path, "preliminary", "subtask0", 0, "sample 1");
        path = "../preliminary/02";
        out = new PrintWriter(path);
        out.println("24");
        out.println("ahahrunawayahahsofasthah");
        out.close();
        printDesc(path, "preliminary", "subtask0", 0, "sample 2");
        path = "../preliminary/03";
        out = new PrintWriter(path);
        out.println("10");
        out.println("ahahaahaha");
        out.close();
        printDesc(path, "preliminary", "subtask0", 0, "sample 3");
    }


    private void shuffle(int[] a) {
        for (int i = 0; i < a.length; i++) {
            int j = rand(a.length);
            int tmp = a[j];
            a[j] = a[i];
            a[i] = tmp;
        }
    }

    //begin generators

    private void genManual() throws IOException {
        print("a");
        printDescT("a");
        print("h");
        printDescT("h");
        print("d");
        printDescT("d");
        print("abacaba");
        printDescT("abacaba");
        print("aaaaaahhhhhhhh");
        printDescT("aaaaaahhhhhhhh");
        print("dhaaaahd");
        printDescT("dhaaaahd");
        
    }

    private void genRand(int n) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i < n; i++) {
            test[i] = randChar();
        }
        print(String.valueOf(test));
        printDescT(String.format("Random: n = %d", n));
    }

    private void genRandAH(int n) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i < n; i++) {
            test[i] = 'a';
            if (coin()) {
                test[i] = 'h';
            }
        }
        print(String.valueOf(test));
        printDescT(String.format("Random [ah]: n = %d", n));
    }

    private void genFullAH(int n) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i + 1 < n; i+=2) {
            test[i] = 'a';
            test[i + 1] = 'h';
        }
        if (n % 2 == 1) {
            test[n - 1] = 'a';
        }
        print(String.valueOf(test));
        printDescT(String.format("Full ahah...: n = %d", n));
    }

    private void genFullHA(int n) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i + 1 < n; i+=2) {
            test[i] = 'h';
            test[i + 1] = 'a';
        }
        if (n % 2 == 1) {
            test[n - 1] = 'h';
        }
        print(String.valueOf(test));
        printDescT(String.format("Full haha...: n = %d", n));
    }

    private void genFullAHRandInserted(int n, int m) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i + 1 < n; i+=2) {
            test[i] = 'a';
            test[i + 1] = 'h';
        }
        if (n % 2 == 1) {
            test[n - 1] = 'a';
        }
        for (int i = 0; i < m; i++) {
            int j = rand(n);
            test[j] = randChar();
        }
        print(String.valueOf(test));
        printDescT(String.format("Full ahah... with %d rand: n = %d", m, n));
    }

    private void genFullHARandInserted(int n, int m) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i + 1 < n; i+=2) {
            test[i] = 'h';
            test[i + 1] = 'a';
        }
        if (n % 2 == 1) {
            test[n - 1] = 'h';
        }
        for (int i = 0; i < m; i++) {
            int j = rand(n);
            test[j] = randChar();
        }
        print(String.valueOf(test));
        printDescT(String.format("Full haha... with %d rand: n = %d", m, n));
    }

    private void genFullHARandInsertedAH(int n, int m) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i + 1 < n; i+=2) {
            test[i] = 'h';
            test[i + 1] = 'a';
        }
        if (n % 2 == 1) {
            test[n - 1] = 'h';
        }
        for (int i = 0; i < m; i++) {
            int j = rand(n);
            test[j] = 'a';
            if (coin()) {
                test[j] = 'h';
            }
        }
        print(String.valueOf(test));
        printDescT(String.format("Full haha... with %d rand [ah]: n = %d", m, n));
    }

    private void genFullAHRandInsertedAH(int n, int m) throws IOException {
        char test[] = new char[n];
        for (int i = 0; i + 1 < n; i+=2) {
            test[i] = 'a';
            test[i + 1] = 'h';
        }
        if (n % 2 == 1) {
            test[n - 1] = 'a';
        }
        for (int i = 0; i < m; i++) {
            int j = rand(n);
            test[j] = 'a';
            if (coin()) {
                test[j] = 'h';
            }
        }
        print(String.valueOf(test));
        printDescT(String.format("Full ahah... with %d rand [ah]: n = %d", m, n));
    }



    //end generators

}
