#include <bits/stdc++.h>

std::vector<std::vector<int>> graph;
std::vector<int> length;
std::vector<long long> sumPath;

void dfs(const std::vector<int>& a, const std::vector<int>& greaterLeft, int v, int cnt, long long sum) {
    length[v] = cnt;
    sumPath[v] = sum + greaterLeft[v];
    for (size_t i = 0; i < graph[v].size(); i++) {
        dfs(a, greaterLeft, graph[v][i], cnt + 1, sum + greaterLeft[v]);
    }
}

int main() {
    freopen("minsumdiff.in", "r", stdin);
    freopen("minsumdiff.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }
    std::vector<std::vector<int>> sparseMax(30, std::vector<int>(n));
    for (int i = 0; i < n; i++) {
        sparseMax[0][i] = a[i];
    }
    for (int j = 1; j < 30; j++) {
        for (int i = 0; i < n; i++) {
            sparseMax[j][i] = sparseMax[j - 1][i];
            if (i + (1 << (j - 1)) < n) {
                sparseMax[j][i] = std::max(sparseMax[j][i], sparseMax[j - 1][i + (1 << (j - 1))]);
            }
        }
    }
    std::vector<int> maxk(n + 1);
    maxk[1] = 0;
    for (int i = 2; i <= n; i++) {
        maxk[i] = maxk[i / 2] + 1;
    }
    auto getMax = [&](int l, int r) {
        int p = maxk[r - l + 1];
        return std::max(sparseMax[p][l], sparseMax[p][r - (1 << p) + 1]);
    };
    std::vector<int> greaterRight(n, -1);
    std::vector<int> greaterLeft(n, -1);
    long long sum = 0;
    for (int i = 0; i < n; i++) {
        int l = i, r = n;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (getMax(i + 1, m) < a[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        if (r < n) {
            greaterRight[i] = r;
        }
        if (getMax(0, i) <= a[i]) {
            sum += i + 1;
            greaterLeft[i] = -1;
            continue;
        }
        l = 0, r = i + 1;
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (getMax(i - m, i) <= a[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        sum += r;
        greaterLeft[i] = i - r;
    }
    std::vector<std::vector<int>> p(30, std::vector<int>(n)); 
    std::vector<bool> isRoot(n, true);
    for (int i = 0; i < n; i++) {
        p[0][i] = i;
    }
    graph.resize(n);
    sumPath.resize(n);
    length.resize(n);
    for (int i = 0; i < n; i++) {
        if (greaterRight[i] != -1) {
            p[0][i] = greaterRight[i];
            graph[greaterRight[i]].push_back(i);
            isRoot[i] = false;
        }
    }
    for (int i = 1; i < 30; i++) {
        for (int j = 0; j < n; j++) {
            p[i][j] = p[i - 1][p[i - 1][j]];
        }
    }
    for (int i = 0; i < n; i++) {
        if (isRoot[i]) {
            dfs(a, greaterLeft, i, 1, 0);
        }
    }
    long long maxDiff = 0;
    for (int i = 0; i < n; i++) {
        int v = i;
        for (int power = 29; power >= 0; power--) {
            if (a[p[power][v]] + 1 - a[i] <= m) {
                v = p[power][v];
            }
        }
        long long diff = i * 1LL * (length[i] - length[v]) - (sumPath[i] - sumPath[v]);
        if (diff > maxDiff) {
            maxDiff = diff;
        }              
    }                                                        
    #ifdef WIN32
        printf("%I64d\n", sum - maxDiff);
    #else
        printf("%lld\n", sum - maxDiff);
    #endif
    return 0;
}            
