import random
import math
random.seed("personal6/minsumdiff")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.subtask = ""
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):
        self.subtask = "subtask0"
        self.print_test(100, [4, 2, 6], "sample1", 0, "preliminary")
        self.print_test(2, [4, 2, 6], "sample2", 0, "preliminary")
        self.print_test(10, [2, 2, 2], "sample3", 0, "preliminary")

    def generate_random_test(self, maxn, maxvalue, m):
        a = []
        for i in range(maxn):
            a.append(random.randint(1, maxvalue // 2) * 2)
        self.print_test(m, a, "random test, n = %d, maxvalue = %d, m = %d" % (maxn, maxvalue, m))

    def generate_first_group_of_tests(self, folder):
        self.subtask = folder
        maxn = 200
        self.print_test(10**9, [4, 2, 6], "a = [4, 2, 6], m = inf")
        self.print_test(10**9, [2, 2, 2], "a = [2, 2, 2], m = inf")
        self.print_test(10**9, [2], "a = [1], m = inf")
        self.print_test(10**9, [2, 2], "a = [1, 1], m = inf")
        self.print_test(10**9, [4, 2], "a = [1, 2], m = inf")
        self.print_test(10**9, [2, 4], "a = [2, 1], m = inf")
        ns = [3, 5, 10, 25, 200]
        for n in ns:
            self.generate_random_test(n, 10, 10**9)

    def generate_second_group_of_tests(self, folder):
        self.subtask = folder
        maxn = 50
        self.print_test(10**9, [10**9], "a = [10^9], m = inf")
        self.print_test(10**9, [4, 2, 6], "a = [4, 2, 6], m = inf")
        self.print_test(10**9, [2, 2, 2], "a = [2, 2, 2], m = inf")
        self.print_test(10**9, [2], "a = [1], m = inf")
        self.print_test(10**9, [10**9], "a = [10^9], m = inf")
        self.print_test(10**9, [2, 2], "a = [1, 1], m = inf")
        self.print_test(10**9, [4, 2], "a = [1, 2], m = inf")
        self.print_test(10**9, [2, 4], "a = [2, 1], m = inf")

        ns = [3, 5, 10, 50]
        for n in ns:
            maxvalues = [10, 1000, 10**6, 10**9]
            for maxvalue in maxvalues:
                self.generate_random_test(n, maxvalue, 10**9)

    def generate_third_group_of_tests(self, folder):
        self.subtask = folder
        maxn = 2000
        self.print_test(10**9, [4, 2, 6], "a = [4, 2, 6], m = inf")
        self.print_test(10**9, [2, 2, 2], "a = [2, 2, 2], m = inf")
        self.print_test(10**9, [2], "a = [1], m = inf")
        self.print_test(10**9, [10**9], "a = [10^9], m = inf")
        self.print_test(10**9, [2, 2], "a = [1, 1], m = inf")
        self.print_test(10**9, [4, 2], "a = [1, 2], m = inf")
        self.print_test(10**9, [2, 4], "a = [2, 1], m = inf")

        ns = [100, 2000]
        for n in ns:
            maxvalues = [10, 1000, 10**6, 10**9]
            for maxvalue in maxvalues:
                self.generate_random_test(n, maxvalue, 10**9)
        self.print_test(10**9, [2 for i in range(maxn)], "a = [2] * 2000, m = inf")
        self.print_test(10**9, [2 for i in range(maxn - 1)] + [4], "a = [2] * 1999 + [4], m = inf")
        self.print_test(10**9, [4] + [2 for i in range(maxn - 1)], "a = [4] + [2] * 1999, m = inf")
        self.print_test(10**9, [i * 2 for i in range(1, maxn + 1)], "a = [2, 4, 6, ...], m = inf")
        self.print_test(10**9, [(maxn - i + 1) * 2 for i in range(1, maxn + 1)], "a = [4000, 3998, ...], m = inf")
        a = 2
        b = maxn * 2
        r = []
        for i in range(maxn // 2):
            if i % 2 == 0:
                r.append(a)
                a += 2
            else:
                r.append(b)
                b -= 2
        self.print_test(10**9, r, "a = [2, 4000, 4, 3998, ... ], m = inf")

    def generate_fourth_group_of_tests(self, folder):
        self.subtask = folder
        self.subtask = folder
        maxn = 10**5
        self.print_test(10**9, [4, 2, 6], "a = [4, 2, 6], m = inf")
        self.print_test(10**9, [2, 2, 2], "a = [2, 2, 2], m = inf")
        self.print_test(10**9, [2], "a = [1], m = inf")
        self.print_test(10**9, [10**9], "a = [10^9], m = inf")
        self.print_test(10**9, [2, 2], "a = [1, 1], m = inf")
        self.print_test(10**9, [4, 2], "a = [1, 2], m = inf")
        self.print_test(10**9, [2, 4], "a = [2, 1], m = inf")

        ns = [5000, 10**5]
        for n in ns:
            maxvalues = [10, 1000, 10**6, 10**9]
            for maxvalue in maxvalues:
                self.generate_random_test(n, maxvalue, 10**9)
        self.print_test(10**9, [2 for i in range(maxn)], "a = [2] * 10**5, m = inf")
        self.print_test(10**9, [2 for i in range(maxn - 1)] + [4], "a = [2] * (10**5 - 1) + [4], m = inf")
        self.print_test(10**9, [4] + [2 for i in range(maxn - 1)], "a = [4] + [2] * (10**5 - 1), m = inf")
        self.print_test(10**9, [i * 2 for i in range(1, maxn + 1)], "a = [2, 4, 6, ...], m = inf")
        self.print_test(10**9, [(maxn - i + 1) * 2 for i in range(1, maxn + 1)], "a = [10**5, 10**5 - 2, ...], m = inf")
        a = 2
        b = maxn * 2
        r = []
        for i in range(maxn // 2):
            if i % 2 == 0:
                r.append(a)
                a += 2
            else:
                r.append(b)
                b -= 2
        self.print_test(10**9, r, "a = [2, 4000, 4, 3998, ... ], m = inf")

    def generate_fifth_group_of_tests(self, folder):
        self.subtask = folder
        maxn = 10**5
        maxvalue = 10**9
        max_leaf_value = 300
        max_diff = 50

        def generate_values(parent, leafs):
            values = [2 for i in range(len(parent))]
            q = []
            for leaf in leafs:
                q.append(leaf)
                values[leaf] = random.randint(1, max_leaf_value // 2) * 2
            head = 0
            while head < len(q):
                v = q[head]
                head += 1
                if values[v] % 4 == 0:
                    values[v] += random.randint(1, max_diff // 2) * 2
                if parent[v] != -1:
                    values[parent[v]] = max(values[parent[v]], values[v])
                    q.append(parent[v])
            leaf_index = random.randint(0, len(leafs) - 1)
            v = leafs[leaf_index]
            height = 0
            while parent[v] != -1:
                height += 1
                v = parent[v]
            if height < 5:
                return [1, values]
            up = random.randint(0, int(math.sqrt(height)) + 1)
            for i in range(up):
                v = parent[v]
            up2 = random.randint(1, height - up)
            u = v
            for i in range(up2):
                u = parent[u]
            m = max(1, values[u] - values[v])
            return [m, values]

        def generate_bamboo(maxn):
            p = [i for i in range(maxn)]
            random.shuffle(p)
            parent = [-1 for i in range(maxn)]
            for i in range(maxn - 1):
                parent[p[i]] = p[i + 1]
            leafs = [p[0]]
            return [parent, leafs]

        def generate_bamboo_with_trash(maxn):
            p = [i for i in range(maxn)]
            random.shuffle(p)
            parent = [-1 for i in range(maxn)]
            k = random.randint(maxn // 2, maxn)
            isLeaf = [True for i in range(maxn)]
            for i in range(k - 1):
                parent[p[i]] = p[i + 1]
                isLeaf[p[i + 1]] = False
            for i in range(k, maxn):
                x = random.randint(0, k - 1)
                parent[p[i]] = p[x]
                isLeaf[p[x]] = False
            leafs = []
            for i in range(maxn):
                if isLeaf[i]:
                    leafs.append(i)
            return [parent, leafs]

        def generate_full_binary(maxn):
            n = 1
            while n <= maxn:
                n *= 2
            n //= 2

            p = [i for i in range(n)]
            random.shuffle(p)
            parent = [-1 for i in range(n)]
            leafs = []

            def generate(v):
                if v * 2 + 2 >= n:
                    leafs.append(p[v])
                    return

                parent[p[v * 2 + 1]] = p[v]
                parent[p[v * 2 + 2]] = p[v]
                generate(v * 2 + 1)
                generate(v * 2 + 2)

            generate(0)
            return [parent, leafs]

        def generate_random_tree(maxn):
            p = [i for i in range(maxn)]
            random.shuffle(p)
            is_leaf = [True for i in range(maxn)]
            parent = [-1 for i in range(maxn)]
            for i in range(1, maxn):
                x = random.randint(0, i - 1)
                parent[p[i]] = p[x]
                is_leaf[p[x]] = False
            leafs = []
            for i in range(maxn):
                if is_leaf[i]:
                    leafs.append(i)
            return [parent, leafs]

        for i in range(5):
            self.generate_random_test(maxn, 10**9, random.randint(1, 10**9))
        a = []
        was = {}
        for i in range(maxn):
            x = random.randint(1, 10**9 // 2) * 2
            while x in was:
                x = random.randint(1, 10**9 // 2) * 2
            was[x] = True
            a.append(x)
        a.sort()
        m = 10**9
        for i in range(len(a) - 1):
            m = min(m, a[i + 1] - a[i])
        random.shuffle(a)
        self.print_test(m, a, "Random test with no changes need to be made")
        parent, leafs = generate_full_binary(maxn)
        m, values = generate_values(parent, leafs)
        self.print_test(m, values, "Max test with full binary tree as array")
        for i in range(5):
            parent, leafs = generate_random_tree(maxn)
            m, values = generate_values(parent, leafs)
            self.print_test(m, values, "Max test with random tree as array")
            parent, leafs = generate_bamboo(maxn)
            m, values = generate_values(parent, leafs)
            self.print_test(m, values, "Max test with bamboo tree as array")
            #parent, leafs = generate_bamboo_with_trash(maxn)
            #m, values = generate_values(parent, leafs)
            #self.print_test(m, values, "Max test with bamboo with trash tree as array")

    def print_test(self, m, a, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %d" % self.test_number)
        
        dirname = os.path.join('..', folder)
        test_name = os.path.join(dirname, "{0:0=2d}".format(self.test_number))
        if not os.path.exists(dirname):
            os.makedirs(dirname)
        test_file = open(test_name, "w")
        print(len(a), m, file=test_file)
        print(' '.join(str(element) for element in a), file=test_file)
        print(test_name + ", folder=" + folder + ", subtask=" + self.subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples() 
        self.test_number = 0
        
        #First group of tests
        self.generate_first_group_of_tests("subtask1")
        print("comment_subtask1=\"n &lt;= 200, a_i &lt;= 10, m = 10^9\"", file=self.desc_file)
        print("bonus_subtask1=19", file=self.desc_file)
        
        #Second group of tests
        self.generate_second_group_of_tests("subtask2")
        print("comment_subtask2=\"n &lt;= 50, m = 10^9\"", file=self.desc_file)
        print("bonus_subtask2=18", file=self.desc_file)

        #Third group of tests
        self.generate_third_group_of_tests("subtask3")
        print("comment_subtask3=\"n &lt;= 2000, m = 10^9\"", file=self.desc_file)
        print("bonus_subtask3=23", file=self.desc_file)
        
        #Fourth group of tests
        self.generate_fourth_group_of_tests("subtask4")
        print("comment_subtask4=\"n &lt;= 10^5, m = 10^9\"", file=self.desc_file)
        print("bonus_subtask4=21", file=self.desc_file)
        
        #Fifth group of tests
        self.generate_fifth_group_of_tests("subtask5")
        print("comment_subtask5=\"n &lt;= 10^5\"", file=self.desc_file)
        print("bonus_subtask5=19", file=self.desc_file)

        self.desc_file.close()

import os, shutil
if os.path.exists('../tests'):
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
if os.path.exists('../preliminary'):
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
    os.makedirs('../preliminary')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
