import java.io.*;
import java.util.*;

public class Polygon_ma_stress {
    String fileName = "";
    final int MOD = 1_000_000_007;
    final int MAXL = 5001;

    public int smart(int n, int[] L) throws IOException {
//        int n = nextInt();
//        int[] L = new int[n];
//        for (int i = 0; i < n; i++) {
//            L[i] = nextInt();
//        }
        Arrays.sort(L);
        long[][] dp = new long[n + 1][MAXL + 1];
        dp[0][0] = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= MAXL; j++) {
                dp[i + 1][j] += dp[i][j];
                dp[i + 1][j] %= MOD;

                dp[i + 1][Math.min(MAXL, j + L[i])] += dp[i][j];
                dp[i + 1][Math.min(MAXL, j + L[i])] %= MOD;
            }
        }
        long[][] suf = new long[n + 1][MAXL + 1];
        for (int j = 0; j <= n; j++) {
            for (int i = MAXL; i >= 0; i--) {
                suf[j][i] = (i == MAXL ? 0 : suf[j][i + 1]) + dp[j][i];
                suf[j][i] %= MOD;
            }
        }

        long cnt = 0;
        for (int i = 0; i < n; i++) {
            cnt += suf[i][L[i] + 1];
            cnt %= MOD;
        }

        return (int) cnt;
//        out.println(cnt);
    }

    public int stupid(int n, int[] L) throws IOException {
//        int n = nextInt();
//        int[] L = new int[n];
//        for (int i = 0; i < n; i++) {
//            L[i] = nextInt();
//        }
        Arrays.sort(L);
        int cnt = 0;
        for (int mask = 0; mask < 1 << n; mask++) {
            int cc = 0;
            int mx = 0;
            int s = 0;
            for (int i = 0; i < n; i++) {
                if (((mask >> i) & 1) == 1) {
                    cc++;
                    mx = L[i];
                    s += L[i];
                }
            }
            s -= mx;
            if (cc >= 3 && s > mx) {
                cnt++;
            }
        }
        return cnt;
    }

    public void solve() throws IOException {
        Random rnd = new Random(239);
        for (int it = 0; it < 10000; it++) {
            if (it % 100 == 0) {
                System.err.println("Test group # " + (it / 100 + 1) + "...");
            }
            int n = rnd.nextInt(15) + 1;
            int[] L = new int[n];
            for (int i = 0; i < n; i++) {
                L[i] = rnd.nextInt(5000) + 1;
            }

            int s1 = smart(n, L);
            int s2 = stupid(n, L);

            if (s1 != s2) {
                System.err.println("BAD!");
                System.err.println(n);
                for (int x : L) {
                    System.err.print(x + " ");
                }
                System.err.println();
                return;
            } else if (it % 100 == 0) {
                System.err.println("OK, s1 = " + s1 + ", s2 = " + s2);
            }
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Polygon_ma_stress().run();
    }

}
