import java.io.*;
import java.util.*;

public class polygon_ma {
    String fileName = "polygon";

    final int MOD = 1_000_000_007;
    final int MAXL = 5001;

    public void solve() throws IOException {
        int n = nextInt();
        int[] L = new int[n];
        for (int i = 0; i < n; i++) {
            L[i] = nextInt();
        }
        Arrays.sort(L);
        long[][] dp = new long[n + 1][MAXL + 1];
        dp[0][0] = 1;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= MAXL; j++) {
                dp[i + 1][j] += dp[i][j];
                dp[i + 1][j] %= MOD;

                dp[i + 1][Math.min(MAXL, j + L[i])] += dp[i][j];
                dp[i + 1][Math.min(MAXL, j + L[i])] %= MOD;
            }
        }
        long[][] suf = new long[n + 1][MAXL + 1];
        for (int j = 0; j <= n; j++) {
            for (int i = MAXL; i >= 0; i--) {
                suf[j][i] = (i == MAXL ? 0 : suf[j][i + 1]) + dp[j][i];
                suf[j][i] %= MOD;
            }
        }

        long cnt = 0;
        for (int i = 0; i < n; i++) {
            cnt += suf[i][L[i] + 1];
            cnt %= MOD;
        }
        out.println(cnt);
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new polygon_ma().run();
    }

}
