#include <iostream>
#include <cstdio>
#include <vector>
#include <cassert>
#include <cstring>
using namespace std;
#define TASK "seating"

const int N = 1e5 + 10;
int gcd(int x, int y) {
    while (x != 0) {
        y %= x;
        swap(x, y);
    }
    return y;
}

bool checkAnswer(int *ans, int n, int d, const vector<int>& a) {
    int cg = 0;
    for (int i = n - d; i < n; ++i)
        if (ans[i]) cg++;
    for (int i = 0; i <= d; ++i)
        if (ans[i]) cg++;
    if (cg != a[0])
        return false;
    for (int i = 1; i < n; ++i) {
        int nx = (i + d) % n;
        if (ans[nx]) cg++;

        int prv = (i - d + n - 1) % n;
        if (ans[prv]) cg--;
        if (cg != a[i])
            return false;
    }
    return true;
}

void push(int s, bool bit, int* ans, int n, int step, int len) {
    for (int i = s, j = 0; j < len; i = (i + step) % n, j++)
        ans[i] = bit;
}

int ans[N];
int main() {
    memset(ans, -1, sizeof ans);
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, d;
    scanf("%d%d", &n, &d);
    vector<int> a(n), starts;
    for (int i = 0; i < n; ++i)
        scanf("%d", &a[i]);
    int g = gcd(n, 2 * d + 1);
    int step = 2 * d + 1;
    int len = n / g;
    int globCnt = -1;

    for (int i = 0; i < g; ++i) {
        int r = i;
        int found = -1;
        int cnt = 0;
        for (int j = 0; j < len && found == -1; r = (r + step) % n, j++) {
            int c = a[(r + d) % n];
            int cn = a[(r + d + 1) % n];
            found = cn - c == 1 ? 1 : cn - c == -1 ? 0 : -1;
            cnt += r < step;
        }

        if (found == -1) {
            if (globCnt == -1) globCnt = cnt;
            else assert(globCnt == cnt);
            starts.push_back(i);
        } else {
            ans[r] = found;
            for (int j = 0; j < len; r = (r + step) % n, j++) {
                int c = a[(r + d) % n];
                int cn = a[(r + d + 1) % n];
                int& nxt = ans[(r + step) % n];
                if (ans[r]) {
                    if (c == cn) nxt = 1;
                    else if (c - cn == 1) nxt = 0;
                    else return cout << "NO\n", 0;
                } else {
                    if (c == cn) nxt = 0;
                    else if (c - cn == -1) nxt = 1;
                    else return cout << "NO\n", 0;
                }
            }
        }
    }

    if (globCnt != -1) {
        int carry = a[d];
        for (int i = 0; i <= 2 * d; ++i)
            if (ans[i] == 1)
                carry--;
        if (carry % globCnt == 0 && carry >= 0) {
            int tot = carry / globCnt;
            for (int j = 0; j < tot; ++j)
                push(starts[j], 1, ans, n, step, len);
            for (int j = tot; j < starts.size(); ++j)
                push(starts[j], 0, ans, n, step, len);
        } else return cout << "NO\n", 0;
    }

    if (!checkAnswer(ans, n, d, a)) cout << "NO\n";
    else {
        cout << "YES\n";
        for (int i = 0; i < n; ++i)
            if (i + 1 != n)
                printf("%d ", ans[i]);
            else
                printf("%d\n", ans[i]);
    }
    return 0;
}
