#include <iostream>
#include <cstdio>
#include <vector>
#include <cassert>
#include <cstring>
using namespace std;
#define TASK "seating"

const int N = 1005;

bool checkAnswer(int *ans, int n, int d, const vector<int>& a) {
    int cg = 0;
    for (int i = n - d; i < n; ++i)
        if (ans[i]) cg++;
    for (int i = 0; i <= d; ++i)
        if (ans[i]) cg++;
    if (cg != a[0])
        return false;
    for (int i = 1; i < n; ++i) {
        int nx = (i + d) % n;
        if (ans[nx]) cg++;

        int prv = (i - d + n - 1) % n;
        if (ans[prv]) cg--;
        if (cg != a[i])
            return false;
    }
    return true;
}

int ans[N];
int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, d;
    scanf("%d%d", &n, &d);
    assert(n <= 1000);
    assert(d <= 5);

    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        scanf("%d", &a[i]);

    int step = 2 * d + 1;
    int tot = 1<<step;
    int r = n - step;
    for (int ms = 0; ms < tot; ++ms) {
        memset(ans, -1, sizeof ans);
        int x = ms;
        for (int i = 0; i <= 2 * d; ++i, x >>= 1)
            ans[i] = x&1;
        bool fail = false;
        for (int i = 0; i < r && !fail; ++i) {
            int c = a[(i + d) % n];
            int nc = a[(i + d + 1) % n];
            if (c == nc) ans[i + step] = ans[i];
            else if (ans[i] && c - nc == 1) ans[i + step] = 0;
            else if (!ans[i] && c - nc == -1) ans[i + step] = 1;
            else fail = true;
        }

        if (!fail && checkAnswer(ans, n, d, a)) {
            cout << "YES\n";
            for (int i = 0; i < n; ++i)
                cout << ans[i] << " ";
            return 0;
        }
    }
    cout << "NO";
    return 0;
}